/* MT_Addin.cpp - MyopicTopics Addin header
 * Written By: Jason Weiler
 * This code is in the public domain
 */

#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <stdio.h>

#include "MT_Addin.h"

ADDIN_API HRESULT WINAPI HandleMyType( DWORD /*dwAddress*/
									  , DEBUGHELPER *pHelper
									  , int nBase
									  , BOOL bUniStrings
									  , char *pResult
									  , size_t maxResult
									  , DWORD /*reserved*/ )
{
	sprintf_s(pResult, maxResult, "Handled Data Type!!");

	return S_OK;
}


/* Code from the project wizard (normally in dllmain.cpp) */
BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}

